LIBRARY RxCPage;

USES Os2Def, Os2Rexx, Strings, Os2PmApi;

{$CDecl+,OrgName+,I-,S-,Delphi+}

CONST
  FunctionTable: Array [0..1] of pChar = ('RxCpTranslate', 'RxUpCase');

Function RxCpLoadFuncs(FuncName  : PChar;
                       ArgC      : ULong;
                       Args      : pRxString;
                       QueueName : pChar;
                       Var Ret   : RxString): ULong; export;
Var
  j: LongInt;
Begin
  Ret.strLength := 0;
  If (ArgC > 0)
    Then                { Do not allow parameters }
      RxCpLoadFuncs := 40
    Else
      Begin
        For j := Low (FunctionTable) To High (FunctionTable) Do
          RexxRegisterFunctionDLL (FunctionTable [j], 'RXCPAGE', FunctionTable [j]);
        RxCpLoadFuncs := 0;
      End;
End;

{ Returns string converted from one codepage to another }

Function RxCpTranslate (FuncName  : PChar;
                        ArgC      : ULong;
                        Args      : pRxString;
                        QueueName : pChar;
                        Var Ret   : RxString): ULong; export;
Var
  i, Err, cpFrom, cpTo: LongInt;
  s: String;
  q, t: PChar;
Begin
  If (ArgC = 0) Then
    Begin
      RxCpTranslate := 40;  { At least one parameter required }
      Exit;
    End;
  For i := 1 To ArgC Do
    Begin
      Case i of
        1: Begin
             q := StrNew (Args^.strptr);
             t := StrNew (Args^.strptr);
           End;
        2: Begin
             s := StrPas (Args^.strptr);
             Val (s, cpFrom, Err);
           End;
        3: Begin
             s := StrPas (Args^.strptr);
             Val (s, cpTo, Err);
           End;
      End;
      Inc (Args);
    End;
  WinCpTranslateString (0, cpFrom, q, cpTo, StrLen (q) + 10, t);
  Ret.StrLength := StrLen (t);
  StrCopy (Ret.strptr, t);
  RxCpTranslate := 0;
End;

{ Converts all line into upper case using current codepage }

Function RxUpCase (FuncName  : PChar;
                   ArgC      : ULong;
                   Args      : pRxString;
                   QueueName : pChar;
                   Var Ret   : RxString): ULong; export;
Var
  i: LongInt;
  q: PChar;
Begin
  If (ArgC = 0) Then
    Begin
      RxUpCase := 40;  { At least one parameter required }
      Exit;
    End;
{
  function WinUpper(AB: Hab; IdCp, IdCc: ULong; Str: PChar): ULong;
}
  For i := 1 To ArgC Do
    Begin
      Case i of
        1: Begin
             q := StrNew (Args^.strptr);
           End;
      End;
      Inc (Args);
    End;
  WinUpper (0, 0, 0, q);
  Ret.StrLength := StrLen (q);
  StrCopy (Ret.strptr, q);
  RxUpCase := 0;
End;

INITIALIZATION
END.

